#include <sys/types.h>
#include <sys/socket.h>
#include <sys/uio.h>

int
recv_names(fd, company, emp1, emp2, emp3, numbytes)
int fd;
char *company;
char *emp1;
char *emp2;
char *emp3;
int numbytes;
{
   struct msghdr msg;
   struct iovec  iov_array[4];

   iov_array[0].iov_base = company;
   iov_array[0].iov_len  = numbytes;

   iov_array[1].iov_base = emp1;
   iov_array[1].iov_len  = numbytes;

   iov_array[2].iov_base = emp2;
   iov_array[2].iov_len  = numbytes;

   iov_array[3].iov_base = emp3;
   iov_array[3].iov_len  = numbytes;

   /*
    *  Fill in the io vector in the message.
    */
   msg.msg_iov    = iov_array;
   msg.msg_iovlen = 4;

   /*
    *  Set the "name" field to 0 because we don't
    *  want the address of our peer.
    */
   
   msg.msg_name    = (caddr_t)0;
   msg.msg_namelen = 0;

   /*
    *  We are not reading access rights in this example,
    *  so set them to 0.
    */

   msg.msg_accrights    = (caddr_t)0;
   msg.msg_accrightslen = 0;

   /*
    *  Read the message from the peer application.
    */

   return(recvmsg(fd, &msg, 0));
}
